package net.minecraftforge.items.wrapper;

import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.item.ItemStack;

/**
 * Exposes the player inventory WITHOUT the armor inventory as IItemHandler.
 * Also takes core of inserting/extracting having the same logic as picking up items.
 */
public class PlayerMainInvWrapper extends RangedWrapper
{
    public final InventoryPlayer inventoryPlayer;

    public PlayerMainInvWrapper(InventoryPlayer inv)
    {
        super(new InvWrapper(inv), 0, inv.field_70462_a.length);
        inventoryPlayer = inv;
    }

    @Override
    public ItemStack insertItem(int slot, ItemStack stack, boolean simulate)
    {
        ItemStack rest = super.insertItem(slot, stack, simulate);
        if (rest == null || rest.field_77994_a != stack.field_77994_a)
        {
            // the stack in the slot changed, animate it
            ItemStack inSlot = getStackInSlot(slot);
            if(inSlot != null)
            {
                if (inventoryPlayer.field_70458_d.field_70170_p.field_72995_K)
                {
                    inSlot.field_77992_b = 5;
                }
                else if(inventoryPlayer.field_70458_d instanceof EntityPlayerMP) {
                    inventoryPlayer.field_70458_d.field_71070_bA.func_75142_b();
                }
            }
        }
        return rest;
    }
}
